CreateDX		proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
DrawDXSubj		proto :DWORD
MoveDXSubj		proto :DWORD, :DWORD, :DWORD

C_FLOAT_MIN	EQU C_FLOAT320x0001
C_FLOAT_MAX	EQU C_FLOAT320x9999

.code

CreateDX	proc uses ebx edi esi, PDEVEXT:DWORD, ADDRSTROUT:DWORD, WEXT:DWORD, HEXT:DWORD, COLOR:DWORD, FLAGPEX:DWORD, FLAGUEX:DWORD

	LOCAL	LCpBB:D3DLOCKED_RECT

	mov	esi, [ADDRSTROUT]

	mov	eax, [WEXT]
	mov	[esi].DX_DRAWSUBJ.szXimg, eax
	mov	eax, [HEXT]
	mov	[esi].DX_DRAWSUBJ.szYimg, eax

	mov	eax, [esi].DX_DRAWSUBJ.szXimg
	dec	eax
	xor	ecx, ecx
CreateDXnormX1:
	inc	ecx
	shr	eax, 1
	jnz	CreateDXnormX1
	mov	eax, 1
	shl	eax, cl
	mov	[esi].DX_DRAWSUBJ.szXtex, eax

	mov	eax, [esi].DX_DRAWSUBJ.szYimg
	dec	eax
	xor	ecx, ecx
CreateDXnormY1:
	inc	ecx
	shr	eax, 1
	jnz	CreateDXnormY1
	mov	eax, 1
	shl	eax, cl
	mov	[esi].DX_DRAWSUBJ.szYtex, eax

	d3dev9	CreateTexture, [PDEVEXT], [esi].DX_DRAWSUBJ.szXtex, [esi].DX_DRAWSUBJ.szYtex, 0, [FLAGUEX], \
		D3DFMT_A8R8G8B8, [FLAGPEX], addr [esi].DX_DRAWSUBJ.pIDtex, 0
	cmp	eax, D3D_OK
	jne	CreateDX_Err

	cmp	[FLAGPEX], D3DPOOL_DEFAULT
	je	CreateDX_NLT

	d3dtex9	LockRect, [esi].DX_DRAWSUBJ.pIDtex, 0, addr [LCpBB], 0, 0
	cmp	eax, D3D_OK
	jne	CreateDX_Err

	mov	edi, [LCpBB.pBits]

	mov	ebx, [COLOR]
	mov	eax, [esi].DX_DRAWSUBJ.szYtex
	xor	edx, edx
	mov	ecx, [esi].DX_DRAWSUBJ.szXtex
	mul	ecx
CreateDXLoadTex4:
	mov	dword ptr [edi], ebx
	add	edi, 4
	dec	eax
	jnz	CreateDXLoadTex4

	d3dtex9	UnlockRect, [esi].DX_DRAWSUBJ.pIDtex, 0

CreateDX_NLT:

	mov	[esi].DX_DRAWSUBJ.Vert1.Z, C_FLOAT321
	mov	[esi].DX_DRAWSUBJ.Vert1.RHW, C_FLOAT321
	mov	[esi].DX_DRAWSUBJ.Vert2.Z, C_FLOAT321
	mov	[esi].DX_DRAWSUBJ.Vert2.RHW, C_FLOAT321
	mov	[esi].DX_DRAWSUBJ.Vert3.Z, C_FLOAT321
	mov	[esi].DX_DRAWSUBJ.Vert3.RHW, C_FLOAT321
	mov	[esi].DX_DRAWSUBJ.Vert4.Z, C_FLOAT321
	mov	[esi].DX_DRAWSUBJ.Vert4.RHW, C_FLOAT321

	mov	[esi].DX_DRAWSUBJ.Ind1, 0
	mov	[esi].DX_DRAWSUBJ.Ind2, 1
	mov	[esi].DX_DRAWSUBJ.Ind3, 2
	mov	[esi].DX_DRAWSUBJ.Ind4, 2
	mov	[esi].DX_DRAWSUBJ.Ind5, 1
	mov	[esi].DX_DRAWSUBJ.Ind6, 3
	
	xor	eax, eax
	ret
CreateDX_Err:
	mov	eax, -1
	ret
CreateDX	endp

DrawDXSubj	proc uses ebx edi esi, SourceStr:DWORD

	LOCAL	ScaleX:DWORD
	LOCAL	ScaleY:DWORD
	LOCAL	KorrektMin:DWORD

	mov	esi, [SourceStr]
	d3dev9	SetTexture, [pdev], 0, [esi].DX_DRAWSUBJ.pIDtex
	cmp	eax, D3D_OK
	jne	DrawDXSubj_Err

	fild	[esi].DX_DRAWSUBJ.xPos
	fst	[esi].DX_DRAWSUBJ.Vert1.X
	fst	[esi].DX_DRAWSUBJ.Vert3.X
	fiadd	[esi].DX_DRAWSUBJ.szXimg
	fst	[esi].DX_DRAWSUBJ.Vert2.X
	fstp	[esi].DX_DRAWSUBJ.Vert4.X

	fild	[esi].DX_DRAWSUBJ.yPos
	fst	[esi].DX_DRAWSUBJ.Vert1.Y
	fst	[esi].DX_DRAWSUBJ.Vert2.Y
	fiadd	[esi].DX_DRAWSUBJ.szYimg
	fst	[esi].DX_DRAWSUBJ.Vert3.Y
	fstp	[esi].DX_DRAWSUBJ.Vert4.Y

	mov	[KorrektMin], C_FLOAT_MIN

	fld1
	fidiv	[esi].DX_DRAWSUBJ.szXtex
	fstp	[ScaleX]

	fld1
	fidiv	[esi].DX_DRAWSUBJ.szYtex
	fstp	[ScaleY]

	mov	[esi].DX_DRAWSUBJ.Vert1.U, C_FLOAT_MIN
	mov	[esi].DX_DRAWSUBJ.Vert3.U, C_FLOAT_MIN
	mov	[esi].DX_DRAWSUBJ.Vert1.V, C_FLOAT_MIN
	mov	[esi].DX_DRAWSUBJ.Vert2.V, C_FLOAT_MIN
	fild	[esi].DX_DRAWSUBJ.szXimg
	fmul	[ScaleX]
	fst	[esi].DX_DRAWSUBJ.Vert2.U
	fstp	[esi].DX_DRAWSUBJ.Vert4.U
	fild	[esi].DX_DRAWSUBJ.szYimg
	fmul	[ScaleY]
	fst	[esi].DX_DRAWSUBJ.Vert3.V
	fstp	[esi].DX_DRAWSUBJ.Vert4.V

 	d3dev9	DrawIndexedPrimitiveUP, [pdev], D3DPT_TRIANGLELIST, 0, 6, 2, \
		addr [esi].DX_DRAWSUBJ.Ind1, D3DFMT_INDEX16, addr [esi].DX_DRAWSUBJ.Vert1, SIZEOF TCUSTOMVERTEX

	d3dev9	SetTexture, [pdev], 0, 0

	xor	eax, eax
	ret
DrawDXSubj_Err:
	mov	eax, -1
	ret
DrawDXSubj	endp

MoveDXSubj	proc uses ebx edi esi, StrLOC:DWORD, Xnew:DWORD, Ynew:DWORD

	mov	edi, [StrLOC]
	mov	eax, [Xnew]
	mov	[edi].DX_DRAWSUBJ.xPos, eax
	mov	eax, [Ynew]
	mov	[edi].DX_DRAWSUBJ.yPos, eax
	ret
MoveDXSubj	endp
