
	.586
	.model flat,stdcall
	option casemap :none   ; case sensitive

	include \masm32\include\windows.inc

	include \masm32\include\kernel32.inc
	include \masm32\include\user32.inc
	include \masm32\include\gdi32.inc
	include \masm32\include\winmm.inc
	include \masm32\Dxsdk90\Include\d3d9.inc
	include \masm32\Dxsdk90\Include\d3dx9tex.inc
	
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\gdi32.lib
	includelib \masm32\lib\winmm.lib
	includelib \masm32\Dxsdk90\lib\d3d9.lib
	includelib \masm32\Dxsdk90\lib\d3dx9.lib

MAIN_REDRAW	EQU WM_USER + 2000

PCUSTOMVERTEX typedef ptr TCUSTOMVERTEX

TCUSTOMVERTEX	struct
	X	dd ?
	Y	dd ?
	Z	dd ?
	RHW	dd ?
	U	dd ?
	V	dd ?
TCUSTOMVERTEX	ends

D3DFVF_CUSTOMVERTEX EQU D3DFVF_XYZRHW or D3DFVF_TEX1

	include main_const.inc
	include game_const.inc
	include float_const.inc
	include data_notinit.asm
	include data_init.asm

	include function_WIN.asm
	include function_DX.asm
	include function_tetris.asm

	include	StartBB.asm	;    
	include	PaintGame.asm		; 

EventTimeCallBack	proto	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD

.code
start:
; initialize the WndClass structure
	mov	[wc.clsStyle], CS_GLOBALCLASS
	mov	[wc.clsLpfnWndProc], offset WndProc
	mov	[wc.clsCbClsExtra], 0
	mov	[wc.clsCbWndExtra], 0

	invoke	GetModuleHandleA, 0
	mov	[hInstance], eax
	mov	[wc.clsHInstance], eax
;-------ikonka---------------
	invoke	LoadIconA , [hInstance], 0
	mov	[wc.clsHIcon], eax

	invoke	LoadCursorA, 0 , IDC_ARROW
	mov	[wc.clsHCursor], eax

	invoke	GetStockObject, COLOR_BACKGROUND
	mov	[wc.clsHbrBackground], COLOR_BTNSHADOW

	mov	[wc.clsLpszMenuName], 0
	mov	[wc.clsLpszClassName], offset szClassName
	invoke	RegisterClassA, offset wc

	invoke	CreateWindowExA, 0,offset szClassName,offset szTitleName, \
		WS_VISIBLE + WS_SYSMENU + WS_GROUP,\
		20, 20,400,400,0,0, [hInstance], 0
	mov	[newhwnd], eax

	invoke	GetClientRect, [newhwnd], offset [rectTemp]
	mov	eax, 400
	sub	eax, [rectTemp.bottom]
	add	eax, SIZE_Y_WIN
	mov	ecx, 400
	sub	ecx, [rectTemp.right]
	add	ecx, SIZE_X_WIN
	invoke	SetWindowPos, [newhwnd], HWND_TOP, 20, 0, ecx, eax, SWP_SHOWWINDOW

	mov	[rejimJob], -1
	invoke	StartBB, [newhwnd]
	cmp	eax, 0
	jne	error_init

	invoke	ShowWindow, [newhwnd], SW_SHOWNORMAL
	invoke	UpdateWindow, [newhwnd]

	invoke	PostMessage, [newhwnd], WM_MOVE, 20, 0

	mov	[rejimJob], 1
	mov	eax, offset EventTimeCallBack
	invoke	timeSetEvent, TIME_CONST, 0, eax, 0, TIME_CALLBACK_FUNCTION + TIME_PERIODIC
	mov	[IdGlobTimer], eax

msg_loop:	
	invoke	GetMessageA, offset msg, 0, 0, 0
	cmp	eax, 0
	je	end_loop
	invoke	TranslateMessage, offset msg
	invoke	DispatchMessageA, offset msg	
	jmp	msg_loop
end_loop:
	invoke    ExitProcess, [msg.msWPARAM]

error_init:
	invoke	MessageBox, [newhwnd], offset [ErrorText], 0, MB_OK + MB_ICONHAND
	invoke	ExitProcess, 0

WndProc	proc uses ebx edi esi, hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD

	cmp	[wmsg], WM_CREATE
	je	wmcreate
	cmp	[wmsg], WM_DESTROY
	je	wmdestroy
	cmp	[wmsg], WM_CLOSE
	je	wmdestroy
	cmp	[wmsg], WM_KEYDOWN
	je	wmkeydown
;	cmp	[wmsg], WM_KEYUP
;	je	wmkeyup
	invoke	DefWindowProcA, [hwnd],[wmsg],[wparam],[lparam]
	ret

wmkeydown:
	cmp	[wparam], 00000026h
	je	wmkeydown_up
	cmp	[wparam], 00000028h
	je	wmkeydown_down
	cmp	[wparam], 00000025h
	je	wmkeydown_left
	cmp	[wparam], 00000027h
	je	wmkeydown_right
	jmp	finish

wmkeydown_up:
	invoke	RotateFigure
	jmp	finish
wmkeydown_down:
        invoke	CheckFigure, addr [figura_e], 0, 1
	cmp	eax, 1
	je	finish
	add	[figura_e.pos_y], SIZE_KUBIK
	jmp	finish
wmkeydown_left:
        invoke	CheckFigure, addr [figura_e], -1, 0
	cmp	eax, 1
	je	finish
	sub	[figura_e.pos_x], SIZE_KUBIK
	jmp	finish
wmkeydown_right:
        invoke	CheckFigure, addr [figura_e], 1, 0
	cmp	eax, 1
	je	finish
	add	[figura_e.pos_x], SIZE_KUBIK
	jmp	finish
finish:
	xor	eax, eax
	ret

;=================================================================
wmcreate:
	finit
	invoke	CreateFontA,14,0,0,0,FW_BOLD,0,0,0, 1,64,0,2,0 + 0, offset [lpFontName1]
	mov	[hFont], eax
	invoke	CreateWindowExA, 0 , addr [StaticClassName], 0, WS_CHILD + WS_VISIBLE + SS_LEFT,\
		0,0,SIZE_X_PAINT,SIZE_Y_PAINT, [hwnd], DrawWinID, [hInstance], 0
	mov	[hClient], eax

	invoke	CreateMstatus, [hwnd], 0, addr [level_txt]
	mov	[houtlevel], eax
	invoke	CreateMstatus, [hwnd], 1, addr [count_txt]
	mov	[houtcount], eax

	invoke	GetTickCount
	invoke	nseed, eax

	invoke	StartLevel, [level]

	invoke	GenericNFigure
	invoke	ShiftFigure
	invoke	GenericNFigure
	mov	[I_temp], 2000
	xor	eax, eax
	ret

wmdestroy:
	invoke	timeKillEvent, [IdGlobTimer]
	invoke	PostQuitMessage, 0
	mov	eax, TRUE
	ret
WndProc          endp

EventTimeCallBack	proc uses ebx edi esi,	uTimerID:DWORD, uMessage:DWORD, dwUser:DWORD, dw1:DWORD, dw2:DWORD

	LOCAL	timeOutLoc:DWORD
	LOCAL	tempLoc:DWORD

	cmp	[rejimJob], 1
	je	EventTimeCallBackM1
	jmp	EventTimeCallBackEnd

EventTimeCallBackM1:
	mov	[timeOutLoc], TIME_CONST

	cmp	[destr_l.flag], 1
	je	EventTimeCallBackM1destr
	mov	[destr_l.flag], 0

	cmp	[figura_e.mov_e], 0
	je	EventTimeCallBackM1mov

	invoke	ShiftFigure
	invoke	GenericNFigure
	invoke	CheckEndGame
	cmp	eax, 0
	je	EventTimeCallBackM1P
	invoke	MessageBox, [newhwnd], offset [end_game_txt], 0, MB_OK + MB_ICONHAND
	invoke	ExitProcess, 0
	
EventTimeCallBackM1mov:
	invoke	MoveFigure, TIME_CONST
	mov	[figura_e.mov_e], eax
	cmp	eax, 0
	je	EventTimeCallBackM1P
	invoke	To_stakan
	invoke	StartDestr
	jmp	EventTimeCallBackM1P

EventTimeCallBackM1destr:
	invoke	PlayDestr, TIME_CONST
	invoke	CheckNextLevel

EventTimeCallBackM1P:
	invoke	PaintGame

EventTimeCallBackEnd:
	xor	eax, eax
	ret
EventTimeCallBack	endp

end start
